import { BaseCreateManager } from "src/core/modules/domain/usecase/managers/base-create.manager";
import { UserPrivilegeEntity } from "../../entities/user-privilege.entity";
import { Injectable } from "@nestjs/common";
import { UserPrivilegeModel } from "../../../data/model/user-privilege.model";
import { EventTopics } from "src/core/strings/constants/interface.constants";
import { UserPrivilegeCreatedEvent } from "../../entities/event/user-privilege-created.event";

@Injectable()
export class CreateUserPrivilegeManager extends BaseCreateManager<UserPrivilegeEntity> {
    
    async validateProcess(): Promise<void> {
        return;
    }

    async beforeProcess(): Promise<void> {
        return;
    }

    async afterProcess(): Promise<void> {
        return;
    }
    
    get eventTopics(): EventTopics[] {
        return [
            {
                topic: UserPrivilegeCreatedEvent,
                data: this.data,
            }
        ];
    }

    get entityTarget(): any {
        return UserPrivilegeModel;
    }
}